STOFFList Class Reference documentation

Public Member Functions | Public Attributes | Protected Attributes | List of all members
STOFFList Class Reference

a small structure used to store the informations about a list More...

`#include <STOFFList.hxx>`

## Public Member Functions
| STOFFList (bool outline)
| default constructor More...
int | getId () const
| returns the list id More...
int | getMarker () const
| returns the actual modify marker More...
void | resize (int levl)
| resize the number of level of the list (keeping only n level) More...
bool | isCompatibleWith (int levl, STOFFListLevel const &level) const
| returns true if we can add a new level in the list without changing is meaning More...
bool | isCompatibleWith (STOFFList const &newList) const
| returns true if the list is compatible with the defined level of new list More...
void | updateIndicesFrom (STOFFList const &list)
| update the indices, the actual level from newList More...
void | swapId () const
| swap the list id More...
void | setId (int newId) const
| set the list id More...
STOFFListLevel | getLevel (int levl) const
| returns a level if it exists More...
int | numLevels () const
| returns the number of level More...
void | set (int levl, STOFFListLevel const &level)
| sets a level More...
void | setLevel (int levl) const
| set the list level More...
void | openElement () const
| open the list element More...
void | closeElement () const
| close the list element More...
int | getStartValueForNextElement () const
| returns the startvalue corresponding to the actual level ( or -1 for an unknown/unordered list) More...
void | setStartValueForNextElement (int value)
| set the startvalue corresponding to the actual level More...
bool | isNumeric (int levl) const
| returns true is a level is numeric More...
bool | addTo (int level, librevenge::RVNGPropertyList &pList) const
| retrieve the list level property More...

## Public Attributes
bool | m_outline
| flag to know if the list is a outline list More...
librevenge::RVNGString | m_name
| the list name More...

## Protected Attributes
std::vector< STOFFListLevel > | m_levels
| the different levels More...
int | m_actLevel
| the actual levels More...
std::vector< int > | m_actualIndices
std::vector< int > | m_nextIndices
int | m_id [2]
| the identificator ( actual and auxilliar ) More...
int | m_modifyMarker
| a modification marker ( can be used to check if a list has been send to a interface ) More...

## Detailed Description

a small structure used to store the informations about a list

## Constructor & Destructor Documentation

## ◆ STOFFList()

STOFFList::STOFFList | ( | bool | outline | ) |
| inlineexplicit

default constructor

## Member Function Documentation

## ◆ addTo()

bool STOFFList::addTo | ( | int | level,
|  | librevenge::RVNGPropertyList & | pList
| ) |  | const

retrieve the list level property

## ◆ closeElement()

void STOFFList::closeElement | ( |  | ) | const
| inline

close the list element

## ◆ getId()

int STOFFList::getId | ( |  | ) | const
| inline

returns the list id

Referenced by addTo().

## ◆ getLevel()

STOFFListLevel STOFFList::getLevel | ( | int | levl | ) | const
| inline

returns a level if it exists

## ◆ getMarker()

int STOFFList::getMarker | ( |  | ) | const
| inline

returns the actual modify marker

## ◆ getStartValueForNextElement()

int STOFFList::getStartValueForNextElement | ( |  | ) | const

returns the startvalue corresponding to the actual level ( or -1 for an unknown/unordered list)

## ◆ isCompatibleWith() [1/2]

bool STOFFList::isCompatibleWith | ( | int | levl,
|  | STOFFListLevel const & | level
| ) |  | const

returns true if we can add a new level in the list without changing is meaning

## ◆ isCompatibleWith() [2/2]

bool STOFFList::isCompatibleWith | ( | STOFFList const & | newList | ) | const

returns true if the list is compatible with the defined level of new list

## ◆ isNumeric()

bool STOFFList::isNumeric | ( | int | levl | ) | const

returns true is a level is numeric

Referenced by getStartValueForNextElement(), and openElement().

## ◆ numLevels()

int STOFFList::numLevels | ( |  | ) | const
| inline

returns the number of level

## ◆ openElement()

void STOFFList::openElement | ( |  | ) | const

open the list element

## ◆ resize()

void STOFFList::resize | ( | int | levl | ) |

resize the number of level of the list (keeping only n level)

Referenced by STOFFListManager::getNewList(), and set().

## ◆ set()

void STOFFList::set | ( | int | levl,
|  | STOFFListLevel const & | level
| ) |  |

sets a level

Referenced by STOFFListManager::getNewList().

## ◆ setId()

void STOFFList::setId | ( | int | newId | ) | const

set the list id

Referenced by addTo(), and STOFFListManager::getNewList().

## ◆ setLevel()

void STOFFList::setLevel | ( | int | levl | ) | const

set the list level

## ◆ setStartValueForNextElement()

void STOFFList::setStartValueForNextElement | ( | int | value | ) |

set the startvalue corresponding to the actual level

## ◆ swapId()

void STOFFList::swapId | ( |  | ) | const
| inline

swap the list id

Note
  a cheat because writerperfect imposes to get a new id if the level 1 changes

## ◆ updateIndicesFrom()

void STOFFList::updateIndicesFrom | ( | STOFFList const & | list | ) |

update the indices, the actual level from newList

## Member Data Documentation

## ◆ m_actLevel

int STOFFList::m_actLevel
| mutableprotected

the actual levels

Referenced by getStartValueForNextElement(), openElement(), resize(), setLevel(), and setStartValueForNextElement().

## ◆ m_actualIndices

std::vector<int> STOFFList::m_actualIndices
| mutableprotected

Referenced by openElement(), resize(), setLevel(), and updateIndicesFrom().

## ◆ m_id

int STOFFList::m_id[2]
| mutableprotected

the identificator ( actual and auxilliar )

Referenced by getId(), setId(), STOFFList(), and swapId().

## ◆ m_levels

std::vector<STOFFListLevel> STOFFList::m_levels
| protected

the different levels

Referenced by addTo(), getLevel(), getStartValueForNextElement(), isCompatibleWith(), isNumeric(), numLevels(), openElement(), resize(), set(), setLevel(), setStartValueForNextElement(), and updateIndicesFrom().

## ◆ m_modifyMarker

int STOFFList::m_modifyMarker
| mutableprotected

a modification marker ( can be used to check if a list has been send to a interface )

Referenced by getMarker(), resize(), set(), setStartValueForNextElement(), and updateIndicesFrom().

## ◆ m_name

librevenge::RVNGString STOFFList::m_name

the list name

## ◆ m_nextIndices

std::vector<int> STOFFList::m_nextIndices
| protected

Referenced by getStartValueForNextElement(), openElement(), resize(), set(), setLevel(), setStartValueForNextElement(), and updateIndicesFrom().

## ◆ m_outline

bool STOFFList::m_outline

flag to know if the list is a outline list

The documentation for this class was generated from the following files:

- STOFFList.hxx
- STOFFList.cxx